/*====================================================================================
This source file is part of the TechTools Plugin Development Kit. 
Copyright (c) 2011 by TechTools  

DISCLAIMERS:
 - NO WARRANTIES
     This software is provided 'As Is', without any express or implied
     warranty of any kind, including but not limited to any warranties 
     of merchantability, noninfringement, or fitness of a particular 
     purpose. The Copyright holders do not warrant or assume responsibility
     for the accuracy or completeness of any information contained within
     this software. 
 - LIMITATION OF LIABILITY
     In no event shall the copyright holders be liable for any damages 
     (including, without limitation, lost profits, business interruption, 
     or lost information) rising out of use of or inability to use this 
     software, even if advised of the possibility of such damages.  In no
     event will the copyright holders be liable for loss of data or for 
     indirect, special, incidental, consequential (including lost profit),
     or other damages based in contract, tort or otherwise. The copyright
     holders shall have no liability with respect to the content of the 
     software or any part thereof, including but not limited to errors or 
     omissions contained therein, libel, infringements of rights of publicity,
     privacy, trademark rights, business interruption, personal injury, 
     loss of privacy, moral rights or the disclosure of confidential
     information.  

Use and redistribution of this software or of derived works, in source or
compiled form is permitted as long as the following restrictions are observed:

- The above copyright(s), disclaimers and these restrictions are retained in the
  source files and, if distributed in compiled form, must be duplicated in 
  documentation or other materials and provided with the distribution.
- The derived work is used exclusively as a plugin to the TechTools DigiView 
  software, to process data captured with TechTools hardware.
- The copyright holders' names may not be used to endorse or to promote any 
  product or derived works.

Any other use is prohibited without express, written permission from TechTools.

email: support@tech-tools.com,  sales@tech-tools.com 
web: www.tech-tools.com   Voice:972-272-9392  FAX: 972-494-5814
======================================================================================*/


// Fully function plug-in (albeit of limited usefullness). Shows minimal requirements.
#include "../plugin.h"

void OnLoad() {}       // no one-time initialization needed
void SetInitItem(unsigned char ID, unsigned char subID, int value) {} // don't care about globals
void SetCfgItem(unsigned char ID, unsigned char subID, int value) {}  // no custom cfg items to set
void StartOfData() {}  // no start-of-parsing inititalization needed
void EndOfData() {}    // no end-of-parsing finalization needed
void OnUnLoad() {}     // no final cleanup needed

void GetStrList(int ID, vector<string> &strl)
{	switch (ID) 
	{  // 0,1 & 5 (descriptions,cfgitems and lookuptables) return empty lists
	case 2:  strl.push_back("State,YELLOW,BLACK,{}"); break; // field format 0
	case 3:  strl.push_back("STATE"); break;      // use STATE pre-parser
	case 4:  strl.push_back("1");	break;        // require framework version 1 or above
	}
}

void Parse(int64 timestamp, Data64 data)
{  // echo all data events as individual formatted fields
	if ((data.bytes[6] & 0x80) == 0x80)  // is a data event (other events are ignored)
		StartField(timestamp,data,0);  // output it with field format 0
}